# Copyright(c) Parag Bajaria
#Licensed under GPL

#import report
import table
import time

correctCount=0
incorrectCount=0
totalTime=0
totalTimeCorrect=0
totalTimeIncorrect=0
#perCatStat={}
perType={}
perTypeTime={}
perTypeQuestions={}


class CatInfo:
    correctCount=0
    incorrectCount=0
    type0=0
    totalTime=0
    incorrectTime=0

    def __str__(self):
        return "correctCount=%d,incorrectCount=%d,totalTime=%d"%(self.correctCount,self.incorrectCount,self.totalTime)

def parse(quest):
    global correctCount
    global incorrectCount
    global totalTime
    global totalTimeCorrect
    global totalTimeIncorrect

    totalTime += quest.timeInSecs
    if not quest.type0 in perType:
        perType[quest.type0]={}

    if not quest.type0 in perTypeTime:
        perTypeTime[quest.type0]=0
    
    if not quest.type0 in perTypeQuestions:
        perTypeQuestions[quest.type0]=0

    perTypeTime[quest.type0] += quest.timeInSecs
    perTypeQuestions[quest.type0] += 1

    perCatStat = perType[quest.type0]

        
    #print quest
    for type1 in quest.type1:
        if  type1 in perCatStat:
            catInfo = perCatStat[type1] 
        else:
            catInfo = CatInfo()
            perCatStat[type1] = catInfo
        if quest.correct:
            correctCount += 1                
            totalTimeCorrect += quest.timeInSecs
            perCatStat[type1].correctCount += 1
        else:
            incorrectCount += 1      
            totalTimeIncorrect += quest.timeInSecs
            perCatStat[type1].incorrectCount += 1
        perCatStat[type1].totalTime += quest.timeInSecs

                

def printPerCatInfo():
    header=['Type','Cor','Incor','Av Time']
    

    for type0 in perType.keys():
        avgTimeType0 = (perTypeTime[type0]/perTypeQuestions[type0])
        print "%s : Average time=%s"%(type0,time.strftime("%M:%S", time.gmtime(avgTimeType0)))

        perCatStat = perType[type0]
        rows = []
        rows.append(header)
        for catInfo in perCatStat.keys():
            row = []
            row.append(catInfo)
            row.append(str(perCatStat[catInfo].correctCount))
            row.append(str(perCatStat[catInfo].incorrectCount))
            totalQues=perCatStat[catInfo].correctCount + perCatStat[catInfo].incorrectCount
            #print totalQues
            #print perCatStat[catInfo].totalTime
            avgTime = float(perCatStat[catInfo].totalTime)/totalQues
            row.append(time.strftime("%M:%S", time.gmtime(avgTime)))
            rows.append(row)
        print table.indent(rows, hasHeader=True,wrapfunc=lambda x: table.wrap_onspace(x,20),separateRows=True,prefix='| ', postfix=' |')



def generateReport(fileGmatData):
    for fileName in fileGmatData.keys():
        #print fileName
        for quest in fileGmatData[fileName].questions:
            parse(quest)

    totalCount=correctCount+incorrectCount
    
    if totalCount != 0:
        printPerCatInfo()
        correctPercent=(float(correctCount)/totalCount)*100
        incorrectPercent=(float(incorrectCount)/totalCount)*100
        averageTime = float(totalTime)/totalCount
        correctTime = float(totalTimeCorrect)/correctCount
        incorrectTime = float(totalTimeIncorrect)/incorrectCount
        print "Average time=" + time.strftime("%M:%S", time.gmtime(averageTime)) \
                + " Correct time=" + time.strftime("%M:%S", time.gmtime(correctTime)) \
                + " Incorrect time=" + time.strftime("%M:%S", time.gmtime(incorrectTime))

        #print "\n"
        print "Correct=%d,Incorrect=%d,Total=%d"%(correctCount,incorrectCount,totalCount)
        print "Correct percent=%d,Incorrect percent=%d"%(abs(correctPercent),abs(incorrectPercent))
    else:
        print "Total count=0"

def Usage():
    print '''
    This reports show % correct % wrong answers
    '''
        
if __name__ == '__main__':
    Usage()

